/*
 * ILI9341_Display_Graph.h
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#ifndef ILI9341_DISPLAY_GRAPH_H_
#define ILI9341_DISPLAY_GRAPH_H_

#include "Dev_Conf.h"

#include def_Header_HAL



//----------------------------------------------------------
// LCDにグラフデータを送信する。 : ILI9341
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_JobNum : 処理番号を格納する変数のポインタ

// uint8_t uint8_Oblong : 縦長/横長
//    0 : Lengthwise : 縦長 左
//    1 : Lengthwise : 縦長 右
//    2 : WidthwiseL : 横長 左
//    3 : WidthwiseR : 横長 右

// uint16_t uint16_StartX : 表示開始位置X
// uint16_t uint16_StartY : 表示開始位置Y

// uint16_t uint16_Width : 表示幅
// uint16_t uint16_Height : 表示高さ

// uint8_t *puint8_aGraphData :
//              Graphデータが格納されているBufferのポインタ


// 戻り値;
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//----------------------------------------------------------
int16_t ILI9341_SPI_Send_GraphData(uint8_t *puint8_JobNum,
                                   uint8_t uint8_Oblong,
                                   uint16_t uint16_StartX,
                                   uint16_t uint16_StartY,
                                   uint16_t uint16_Width,
                                   uint16_t uint16_Height,
                                   uint8_t *puint8_aGraphData);



#endif /* ILI9341_DISPLAY_GRAPH_H_ */
