/*
 * MSP2807_Test_TP.h
 *
 *  Created on: 2025/02/25
 *      Author: egaono-electronics
 */

#ifndef MSP2807_TEST_TP_H_
#define MSP2807_TEST_TP_H_

#include "Dev_Conf.h"

#include def_Header_HAL

#include "XPT2046_TP_Adjust.h"
#include "XPT2046_TP_Detect.h"
#include "XPT2046_TP_Access.h"



//--------------------------------------------------------------
// MSP2807のタッチパネル試験
//--------------------------------------------------------------
// 引数：
// uint8_t *puint8_JobNum : 処理番号が格納された変数のポインタ

// struct sParam_Position_TP *pstructParam_Position_TP :
//          タッチパネル位置取得用パラメータの構造体のポインタ

// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//          タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//--------------------------------------------------------------
int16_t MSP2807_Test_TP(uint8_t *puint8_JobNum,
            struct sParam_Position_TP *pstructParam_Position_TP,
            struct sParam_Adjust_TP *pstructParam_Adjust_TP,
            struct sParam_TP_SW *pstructParam_TP_SW);



//--------------------------------------------------------------
// タッチパネルの入力データを表示する。
//--------------------------------------------------------------
// 引数：
// uint8_t *puint8_JobNum : 処理番号が格納される変数のポインタ

// int16_t uint16_Num_Data_Input : データ長
// uint8_t *puint8_aData_Buffer :
//                  入力Dataが格納されているBufferのポインタ

// 戻り値：
//   -1 : 処理中
//    0 : OK終了
//    1 : NG終了
//--------------------------------------------------------------
int16_t Draw_TP_SW_Input_Data(uint8_t *puint8_JobNum,
                               uint16_t uint16_Num_Data_Input,
                               uint8_t *puint8_aData_Buffer);



#endif /* MSP2807_TEST_TP_H_ */
