﻿/*
 * MSP2807_Test_TP_Detect.c
 *
 *  Created on: 2025/02/25
 *      Author: egaono-electronics
 */

#include "MSP2807_Test_TP_Detect.h"

#include "ILI9341_SPI_Draw.h"

#include "MSP2807_Test_TP_Key_In.h"


#include <string.h>



//--------------------------------------------------------------
// Test TP SW Functionの値を設定
//--------------------------------------------------------------
// 引数:
// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Value_Function(
                    struct sParam_TP_SW *pstructParam_TP_SW)
{
  int16_t int16_I;


  // Function
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_BK], "BK");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_FW], "FW");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_BS], "BS");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_DL], "DL");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_ET], "ET");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_AH], "AH");
  strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                            (int16_t)def_Num_TP_SW_Func_CL], "CL");



  // TP検出フラグセット
  for(int16_I = (int16_t)def_Num_TP_SW_Func_BK;
      int16_I <= (int16_t)def_Num_TP_SW_Func_CL; int16_I++){
    pstructParam_TP_SW->int16_aFlag_Detect_TP_SW[int16_I] = 1;
  }
}



//--------------------------------------------------------------
// Test TP SW Upper case/Lower caseの値を設定 : UL
//--------------------------------------------------------------
// 引数:
// int16_t int16_Sel : 表示選択
//    0 : 表示 : ASCII
//    1 : 消去 : HEX

// struct sParam_TP_SW *pstructParam_TP_SW :
//          タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Value_Upper_Lower(int16_t int16_Sel,
                    struct sParam_TP_SW *pstructParam_TP_SW)
{
  if(int16_Sel == 0){
    // 表示
    strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                        (int16_t)def_Num_TP_SW_Func_UL], "UL");

    // TP検出フラグセット
    pstructParam_TP_SW->int16_aFlag_Detect_TP_SW[
                        (int16_t)def_Num_TP_SW_Func_UL] = 1;
  }
  else{
    // 消去
    strcpy((char *)pstructParam_TP_SW->uint8_aDraw_Data_TP_SW[
                        (int16_t)def_Num_TP_SW_Func_UL], "  ");

    // TP検出フラグクリア
    pstructParam_TP_SW->int16_aFlag_Detect_TP_SW[
                        (int16_t)def_Num_TP_SW_Func_UL] = 0;
  }
}



//--------------------------------------------------------------
// Test TP SWの表示位置と検出位置をセット
//--------------------------------------------------------------
// struct sParam_Adjust_TP *pstructParam_Adjust_TP :
//              タッチパネル位置調整用パラメータ構造体のポインタ

// struct sParam_TP_SW *pstructParam_TP_SW :
//              タッチパネルスイッチ用パラメータの構造体のポインタ


// 戻り値：
//    なし
//--------------------------------------------------------------
void Set_Test_TP_SW_Position(
                struct sParam_Adjust_TP *pstructParam_Adjust_TP,
                struct sParam_TP_SW *pstructParam_TP_SW)
{
  int16_t int16_I;


  //----------------------------------------------------------------
  // 0 - 9, A - Z
  //----------------------------------------------------------------
  // Key_0
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_0]
                                = (int16_t)def_Pos_X_TP_SW_Key_0;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_0]
                                = (int16_t)def_Pos_Y_TP_SW_Key_0;

  // Key_1 - Key_9
  // Key_A - Key_F
  for(int16_I = (int16_t)def_Num_TP_SW_Key_1;
      int16_I <= (int16_t)def_Num_TP_SW_Key_F; int16_I++){
    pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I]
        = pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I - 1]
                                + (int16_t)def_Interval_TP_SW_Key;

    pstructParam_TP_SW->int16_aPos_Y_Draw_TP_SW[int16_I]
                                = (int16_t)def_Pos_Y_TP_SW_Key_0;
  }


  // Key_G
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_G]
                                = (int16_t)def_Pos_X_TP_SW_Key_G;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_G]
                                = (int16_t)def_Pos_Y_TP_SW_Key_G;

  // Key_H - Key_V
  for(int16_I = (int16_t)def_Num_TP_SW_Key_H;
      int16_I <= (int16_t)def_Num_TP_SW_Key_V; int16_I++){
    pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I]
        = pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I - 1]
                                + (int16_t)def_Interval_TP_SW_Key;

    pstructParam_TP_SW->int16_aPos_Y_Draw_TP_SW[int16_I]
                                = (int16_t)def_Pos_Y_TP_SW_Key_G;
  }


  // Key_W
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_W]
                                = (int16_t)def_Pos_X_TP_SW_Key_W;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_W]
                                = (int16_t)def_Pos_Y_TP_SW_Key_W;

  // Key_X - Key_Z
  for(int16_I = (int16_t)def_Num_TP_SW_Key_X;
      int16_I <= (int16_t)def_Num_TP_SW_Key_Z; int16_I++){
    pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I]
        = pstructParam_TP_SW->int16_aPos_X_Draw_TP_SW[int16_I - 1]
                                + (int16_t)def_Interval_TP_SW_Key;

    pstructParam_TP_SW->int16_aPos_Y_Draw_TP_SW[int16_I]
                                = (int16_t)def_Pos_Y_TP_SW_Key_W;
  }
  //----------------------------------------------------------------



  //----------------------------------------------------------------
  // Control Code : 制御コード
  //----------------------------------------------------------------
  // Space
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_SP]
                                = (int16_t)def_Pos_X_TP_SW_Key_SP;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_SP]
                                = (int16_t)def_Pos_Y_TP_SW_Key_SP;


  // CR
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_CR]
                                = (int16_t)def_Pos_X_TP_SW_Key_CR;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_CR]
                                = (int16_t)def_Pos_Y_TP_SW_Key_CR;


  // LF
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_LF]
                                = (int16_t)def_Pos_X_TP_SW_Key_LF;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Key_LF]
                                = (int16_t)def_Pos_Y_TP_SW_Key_LF;
  //----------------------------------------------------------------



  //----------------------------------------------------------------
  // Function Key
  //----------------------------------------------------------------
  // Func_BK
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_BK]
                                = (int16_t)def_Pos_X_TP_SW_Func_BK;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_BK]
                                = (int16_t)def_Pos_Y_TP_SW_Func_BK;


  // Func_FW
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_FW]
                                = (int16_t)def_Pos_X_TP_SW_Func_FW;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_FW]
                                = (int16_t)def_Pos_Y_TP_SW_Func_FW;


  // Func_BS
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_BS]
                                = (int16_t)def_Pos_X_TP_SW_Func_BS;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_BS]
                                = (int16_t)def_Pos_Y_TP_SW_Func_BS;


  // Func_DL
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_DL]
                                = (int16_t)def_Pos_X_TP_SW_Func_DL;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_DL]
                                = (int16_t)def_Pos_Y_TP_SW_Func_DL;


  // Func_ET
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_ET]
                                = (int16_t)def_Pos_X_TP_SW_Func_ET;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_ET]
                                = (int16_t)def_Pos_Y_TP_SW_Func_ET;


  // Func_AH
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_AH]
                                = (int16_t)def_Pos_X_TP_SW_Func_AH;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_AH]
                                = (int16_t)def_Pos_Y_TP_SW_Func_AH;


  // Func_CL
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_CL]
                                = (int16_t)def_Pos_X_TP_SW_Func_CL;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_CL]
                                = (int16_t)def_Pos_Y_TP_SW_Func_CL;


  // Func_UL
  pstructParam_TP_SW->
            int16_aPos_X_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_UL]
                                = (int16_t)def_Pos_X_TP_SW_Func_UL;

  pstructParam_TP_SW->
            int16_aPos_Y_Draw_TP_SW[(int16_t)def_Num_TP_SW_Func_UL]
                                = (int16_t)def_Pos_Y_TP_SW_Func_UL;
  //----------------------------------------------------------------



  //----------------------------------------------------------------
  // TP SW 表示パラメータセット : スイッチの表示サイズ
  //----------------------------------------------------------------
  // 0 - 9, A - Z, Space, CR, LF
  for(int16_I = 0;
            int16_I <= (int16_t)def_Num_TP_SW_Al_Nu; int16_I++){
    pstructParam_TP_SW->int16_aWidth_TP_SW[int16_I]
                                = (int16_t)def_Width_Button_Key_In;
    pstructParam_TP_SW->int16_aHeight_TP_SW[int16_I]
                                = (int16_t)def_Height_Button_Key_In;

    pstructParam_TP_SW->uint16_aFont_TP_SW[int16_I]
                                = (uint16_t)def_Font_ASCII_16x16;
  }


  //----------------------------------------------------------------
  // スイッチの表示色セット
  //----------------------------------------------------------------
  // 0 - 9
  for(int16_I = (int16_t)def_Num_TP_SW_Key_0;
           int16_I <= (int16_t)def_Num_TP_SW_Key_9; int16_I++){
    pstructParam_TP_SW->uint32_aColor_TP_SW[int16_I]
                                = (uint32_t)def_Color_TP_SW_0_9;
  }


  // A - Z
  for(int16_I = (int16_t)def_Num_TP_SW_Key_A;
           int16_I <= (int16_t)def_Num_TP_SW_Key_Z; int16_I++){
    pstructParam_TP_SW->uint32_aColor_TP_SW[int16_I]
                                = (uint32_t)def_Color_TP_SW_Key;
  }


  // Space, CR, LF
  pstructParam_TP_SW->
            uint32_aColor_TP_SW[(int16_t)def_Num_TP_SW_Key_SP]
                                = (uint32_t)def_Color_TP_SW_SP;
  pstructParam_TP_SW->
            uint32_aColor_TP_SW[(int16_t)def_Num_TP_SW_Key_CR]
                                = (uint32_t)def_Color_TP_SW_CR;
  pstructParam_TP_SW->
            uint32_aColor_TP_SW[(int16_t)def_Num_TP_SW_Key_LF]
                                = (uint32_t)def_Color_TP_SW_LF;



  //----------------------------------------------------------------
  // Function スイッチのパラメータセット
  //----------------------------------------------------------------
  // BK, FW, BS, DL, ET, AH, CL, UL
  for(int16_I = (int16_t)def_Num_TP_SW_Func_BK;
      int16_I <= (int16_t)def_Num_TP_SW_Key_Func; int16_I++){
    pstructParam_TP_SW->int16_aWidth_TP_SW[int16_I]
                                = (int16_t)def_Width_Button_Func_In;
    pstructParam_TP_SW->int16_aHeight_TP_SW[int16_I]
                                = (int16_t)def_Height_Button_Func_In;

    pstructParam_TP_SW->uint16_aFont_TP_SW[int16_I]
                                = (uint16_t)def_Font_ASCII_16x16;
    pstructParam_TP_SW->uint32_aColor_TP_SW[int16_I]
                                = (uint32_t)def_Color_TP_SW_Function;
  }
  //----------------------------------------------------------------


  //---------------------------------------
  // UL の色セット
  //---------------------------------------
  pstructParam_TP_SW->
            uint32_aColor_TP_SW[(int16_t)def_Num_TP_SW_Func_UL]
                                = (uint32_t)def_Color_TP_SW_UL;



  //----------------------------------------------------------------
  // タッチパネル上のスイッチのXY位置を算出 : Alpha Numeric
  //----------------------------------------------------------------
  // タッチパネル上のスイッチ位置を保存するグローバル変数にセットする。
  //----------------------------------------------------------------
  // 引数:
  // int16_t int16_Num_SW_Start : 開始スイッチ番号
  // int16_t int16_Num_SW_End : 終了スイッチ番号

  // struct sParam_Adjust_TP *pstructParam_Adjust_TP :
  //            タッチパネル位置調整用パラメータ構造体のポインタ

  // struct sParam_TP_SW *pstructParam_TP_SW :
  //            タッチパネルスイッチ用パラメータの構造体のポインタ


  // 戻り値：
  //    なし
  //----------------------------------------------------------------
  Calc_TP_SW_XY((int16_t)def_Num_TP_SW_Key_0,
                (int16_t)def_Num_TP_SW_Key_Func,
                pstructParam_Adjust_TP,
                pstructParam_TP_SW);
}
