﻿/*
 * Modules_Lib.c
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#include "Modules_Lib.h"


#include <stdio.h>
#include <string.h>


//----------------------------------------------------------
// ASCII文字 2byte を Binary 1byteに変換 :
//          例 ASCII文字 2byte "0D" --> Binary 1byte 0x0D
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_Buff :
//          ASCII文字 2byteが格納されているBufferのポインタ
// uint8_t *puint8_aData :
//          変換した Binary 1byte を格納する変数のポインタ


// 戻り値:
//    なし
//----------------------------------------------------------
void commonConv2CharToByte(uint8_t *puint8_Buff,
                           uint8_t *puint8_aData)
{
  if(puint8_Buff[0] <= '9'){
    *puint8_aData = puint8_Buff[0] & 0x0f;
  }
  else{
    *puint8_aData = puint8_Buff[0] - 55;
  }

  *puint8_aData <<= 4;

  if(puint8_Buff[1] <= '9'){
    *puint8_aData |= puint8_Buff[1] & 0x0f;
  }
  else{
    *puint8_aData |= puint8_Buff[1] - 55;
  }
}



//----------------------------------------------------------
// 配列の要素を交換する。
//----------------------------------------------------------
// 引数:
// int16_t *pint16_aData : データ配列のポインタ

// int16_t int16_I : 交換位置 I
// int16_t int16_J : 交換位置 J


// 戻り値:
//    なし
//----------------------------------------------------------
void Swap_Array(int16_t *pint16_aData,
                int16_t int16_I, int16_t int16_J)
{
  int16_t int16_Temp;


  int16_Temp = pint16_aData[int16_I];
  pint16_aData[int16_I] = pint16_aData[int16_J];
  pint16_aData[int16_J] = int16_Temp;
}



//----------------------------------------------------------
// 小さい順に並べる。
//----------------------------------------------------------
// 引数;
// int16_t int16_Number : データ数
// int16_t *pint16_aData :
//              データが格納されているBufferのポインタ


// 戻り値:
//    なし
//----------------------------------------------------------
void Sort_Small_to_Large(int16_t int16_Number,
                         int16_t *pint16_aData)
{
  int16_t int16_I;
  int16_t int16_J;

  int16_t int16_Count;


  int16_Count = int16_Number -1;
  for(int16_I = 0; int16_I < int16_Number - 1; int16_I++){
    for(int16_J = 0; int16_J < int16_Count; int16_J++){
      if(pint16_aData[int16_J] > pint16_aData[int16_J + 1]){
        Swap_Array(pint16_aData, int16_J, int16_J + 1);
      }
    }

    int16_Count--;
  }
}
