﻿/*
 * Modules_Lib.h
 *
 *  Created on: 2024/11/18
 *      Author: egaono-electronics
 */

#ifndef MODULES_LIB_H_
#define MODULES_LIB_H_

#include "Dev_Conf.h"

#include def_Header_HAL



//----------------------------------------------------------
// ASCII文字 2byte を Binary 1byteに変換 :
//          例 ASCII文字 2byte "0D" --> Binary 1byte 0x0D
//----------------------------------------------------------
// 引数;
// uint8_t *puint8_Buff :
//          ASCII文字 2byteが格納されているBufferのポインタ
// uint8_t *puint8_aData :
//          変換した Binary 1byte を格納する変数のポインタ


// 戻り値:
//    なし
//----------------------------------------------------------
void commonConv2CharToByte(uint8_t *puint8_Buff,
                           uint8_t *puint8_aData);



//----------------------------------------------------------
// 配列の要素を交換する。
//----------------------------------------------------------
// 引数:
// int16_t *pint16_aData : データ配列のポインタ

// int16_t int16_I : 交換位置 I
// int16_t int16_J : 交換位置 J


// 戻り値:
//    なし
//----------------------------------------------------------
void Swap_Array(int16_t *pint16_aData,
                int16_t int16_I, int16_t int16_J);



//----------------------------------------------------------
// 小さい順に並べる。
//----------------------------------------------------------
// 引数;
// int16_t int16_Number : データ数
// int16_t *pint16_aData :
//              データが格納されているBufferのポインタ


// 戻り値:
//    なし
//----------------------------------------------------------
void Sort_Small_to_Large(int16_t int16_Number,
                         int16_t *pint16_aData);



#endif /* MODULES_LIB_H_ */
